/*!
    \file  ihandlers.h
    \brief interrupt handlers

    definition for IDT
    Copyright (c) 2003 Higepon
    WITHOUT ANY WARRANTY

    \author  Higepon
    \version $Revision$
    \date   create:2003/02/24 update:$Date$
*/
#ifndef _MONA_IHANDLER_
#define _MONA_IHANDLER_

extern void gdbCatchException(int exceptionVector);
extern "C" void arch_dummyhandler(void);
extern "C" void arch_syscall_handler(void);
extern "C" void dummyHandler(void);
extern "C" void SendInterrupt(int irq);

/* IRQ Handler */
#define IRQHANDLERHEADER(x) extern "C" void irqHandler_##x(); extern "C" void arch_irqhandler_##x()
IRQHANDLERHEADER(0);
IRQHANDLERHEADER(1);
IRQHANDLERHEADER(2);
IRQHANDLERHEADER(3);
IRQHANDLERHEADER(4);
IRQHANDLERHEADER(5);
IRQHANDLERHEADER(6);
IRQHANDLERHEADER(7);
IRQHANDLERHEADER(8);
IRQHANDLERHEADER(9);
IRQHANDLERHEADER(10);
IRQHANDLERHEADER(11);
IRQHANDLERHEADER(12);
IRQHANDLERHEADER(13);
IRQHANDLERHEADER(14);
IRQHANDLERHEADER(15);

#define VECTOR_DIVIDE_ERROR_EXCEPTION 0
#define VECTOR_DEBUG_EXCEPTION 1
#define VECTOR_NMI_INTTERUPT 2
#define VECTOR_BREAKPOINT_EXCEPTION 3
#define VECTOR_OVERFLOW_EXCEPTION 4
#define VECTOR_BOUND_RANGE_EXCEEDED_EXCEPTION 5
#define VECTOR_INVALID_OP_CODE_EXCEPTION 6
#define VECTOR_DEVICE_NOT_AVAILABLE__EXCEPTION 7
#define VECTOR_DOUBLE_FAULT_EXCEPTION 8
#define VECTOR_COPROCESSOR_SEGMENT_OVERRUN 9
#define VECTOR_INVALID_TSS_EXCEPTION 10
#define VECTOR_SEGMENT_NOT_PRESENT 11
#define VECTOR_STACK_FAULT_EXCEPTION 12
#define VECTOR_GENERAL_PROTECTION_EXCEPTION 13
#define VECTOR_PAGE_FAULT_EXCEPTION 14
#define VECTOR_X87_FLOATING_POINT_ERROR 16
#define VECTOR_ALIGNMENT_CHECK_EXCEPTION 17
#define VECTOR_MACHINE_CHECK_EXCEPTION 18
#define VECTOR_SIMD_FLOATING_POINT_EXCEPTION 19

void dokodemoView();

#endif
